$button-hover-color: #134a81;
$header-border-color: #e8e8e8;
$minimum-supported-viewport: 900px;
$shadow-color: rgba(0, 0, 0, .4);
$spinner-color: #292961;
$spinner-size: 40px;

$sidebar-min-width: 820px;
$sidebar-max-width: 1290px;
$sidebar-width: 70%; // must be a percentage
$issuable-sidebar-width: 289px;
// Minimum width at which the min-width: 820px stops being effective;
$min-width-breakpoint: $sidebar-min-width / ($sidebar-width / 100%);
$max-width-breakpoint: $sidebar-max-width / ($sidebar-width / 100%);

.issue-boards-sidebar {
  @media (min-width: #{$minimum-supported-viewport}) {
    &.right-sidebar {
      box-shadow: 0 0 30px $shadow-color;
      display: flex;
      transition: none;
    }

    body:not(.gitlab-sidebar-detail--collapsed) & {
      max-width: $sidebar-max-width;
      min-width: $sidebar-min-width;
      width: 70% !important;
    }

    &.right-sidebar-expanded {
      &.boards-sidebar-slide-enter,
      &.boards-sidebar-slide-leave-to {
        transform: translateX(100%);
      }

      &.boards-sidebar-slide-enter-active,
      &.boards-sidebar-slide-leave-active {
        transition: transform .3s;
      }
    }

    .issuable-header-text {
      border-right: 1px solid $header-border-color;
      display: block;
      float: none !important;
      margin-right: 35px;
      min-height: 64px;
      padding-right: 0 !important;

    }

    .issuable-sidebar-header .gutter-toggle {
      bottom: 50% !important;
      border-left: 0 none !important;
    }
  }
}

.issuable-sidebar {
  @media (min-width: #{$minimum-supported-viewport}) {
    width: $issuable-sidebar-width !important;
  }
}

.sidebar-iframe {
  border-right: 1px solid #e3e3e3;
  flex: 1;
  position: relative;
  transition: opacity .15s;

  @media (max-width: #{$minimum-supported-viewport - 1px}) {
    display: none;
  }

  iframe {
    border: 0 none;
    height: 100%;
    width: 100%;
  }

  &--loading {
    opacity: 0;
  }

  body.gitlab-sidebar-detail--collapsed .issue-boards-sidebar & {
    display: none;
  }
}

.gitlab-sidebar-expanded-toggle {
  background: transparent;
  border: 0 none;
  bottom: 0;
  font-size: 22px;
  margin-bottom: 7px;
  padding: 0;
  position: absolute;
  right: 0;
  text-align: right;
  top: 50%;
  width: 34px;

  @media (max-width: #{$minimum-supported-viewport - 1px}) {
    display: none;
  }

  &:hover {
    color: $button-hover-color;
  }

  &::after {
    content: '»';
  }

  &--collapsed::after {
    content: '«';
  }
}

.gitlab-sidebar-loading-spinner {
  display: block;
  height: #{$spinner-size};
  left: 50%;
  margin: -#{$spinner-size / 2} -#{$spinner-size / 2} 0 0;
  position: absolute;
  top: 50%;
  width: #{$spinner-size};
  z-index: -1;

  &::after {
    animation: gitlab-sidebar-loading-spinner 1s linear infinite;
    border: #{$spinner-size * .075} solid $spinner-color;
    border-color: $spinner-color transparent $spinner-color transparent;
    border-radius: 50%;
    content: '';
    display: block;
    height: #{$spinner-size * .8};
    margin: #{$spinner-size * .1};
    width: #{$spinner-size * .8};
  }
}

body:not(.gitlab-sidebar-detail--collapsed) .boards-app.is-compact .board:last-child {
  @media (min-width: $min-width-breakpoint) {
    $width-vw: $sidebar-width / 100% * 100vw; // convert % to vw
    margin-right: calc(#{$width-vw} - #{$issuable-sidebar-width});
  }

  @media (min-width: $max-width-breakpoint) {
    margin-right: $sidebar-max-width - $issuable-sidebar-width;
  }
}

@keyframes gitlab-sidebar-loading-spinner {
  0% {
    transform: rotate(0deg);
  }
  100% {
    transform: rotate(360deg);
  }
}
